/*
 * Created on 2019-08-18 ( Time 17:15:15 )
 * Generated by Telosys Tools Generator ( version 3.0.0 )
 */
// This Bean has a basic Primary Key (not composite) 

package ci.diaspora.star.motors.sarl.dao.entity;

import java.io.Serializable;

//import javax.validation.constraints.* ;
//import org.hibernate.validator.constraints.* ;

import java.util.Date;

import javax.persistence.*;

/**
 * Persistent class for entity stored in table "travaux_effectues"
 *
 * @author Telosys Tools Generator
 *
 */

@Entity
@Table(name="travaux_effectues" )
public class TravauxEffectues implements Serializable, Cloneable {

    private static final long serialVersionUID = 1L;

    //----------------------------------------------------------------------
    // ENTITY PRIMARY KEY ( BASED ON A SINGLE FIELD )
    //----------------------------------------------------------------------
	/*
	 * 
	 */
    @Id
    @GeneratedValue(strategy=GenerationType.AUTO)
    @Column(name="id", nullable=false)
    private Integer    id           ;


    //----------------------------------------------------------------------
    // ENTITY DATA FIELDS 
    //----------------------------------------------------------------------    
	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="date_debut_travaux")
    private Date       dateDebutTravaux ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="date_fin_travaux")
    private Date       dateFinTravaux ;

	/*
	 * 
	 */
    @Column(name="is_signed")
    private Boolean    isSigned     ;

	/*
	 * 
	 */
    @Column(name="is_deleted")
    private Boolean    isDeleted    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="created_at")
    private Date       createdAt    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="updated_at")
    private Date       updatedAt    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="deleted_at")
    private Date       deletedAt    ;

	/*
	 * 
	 */
    @Column(name="created_by")
    private Integer    createdBy    ;

	/*
	 * 
	 */
    @Column(name="updated_by")
    private Integer    updatedBy    ;

	/*
	 * 
	 */
    @Column(name="deleted_by")
    private Integer    deletedBy    ;

	// "ordreReparationId" (column "ordre_reparation_id") is not defined by itself because used as FK in a link 
	// "designationTravauxEffectuesId" (column "designation_travaux_effectues_id") is not defined by itself because used as FK in a link 
	// "userTechnicienId" (column "user_technicien_id") is not defined by itself because used as FK in a link 


    //----------------------------------------------------------------------
    // ENTITY LINKS ( RELATIONSHIP )
    //----------------------------------------------------------------------
    @ManyToOne
    @JoinColumn(name="designation_travaux_effectues_id", referencedColumnName="id")
    private DesignationTravauxEffectues designationTravauxEffectues;
    @ManyToOne
    @JoinColumn(name="user_technicien_id", referencedColumnName="id")
    private User user        ;
    @ManyToOne
    @JoinColumn(name="ordre_reparation_id", referencedColumnName="id")
    private OrdreReparation ordreReparation;

    //----------------------------------------------------------------------
    // CONSTRUCTOR(S)
    //----------------------------------------------------------------------
    public TravauxEffectues() {
		super();
    }
    
    //----------------------------------------------------------------------
    // GETTER & SETTER FOR THE KEY FIELD
    //----------------------------------------------------------------------
    public void setId( Integer id ) {
        this.id = id ;
    }
    public Integer getId() {
        return this.id;
    }

    //----------------------------------------------------------------------
    // GETTERS & SETTERS FOR FIELDS
    //----------------------------------------------------------------------
    //--- DATABASE MAPPING : date_debut_travaux ( DATETIME ) 
    public void setDateDebutTravaux( Date dateDebutTravaux ) {
        this.dateDebutTravaux = dateDebutTravaux;
    }
    public Date getDateDebutTravaux() {
        return this.dateDebutTravaux;
    }

    //--- DATABASE MAPPING : date_fin_travaux ( DATETIME ) 
    public void setDateFinTravaux( Date dateFinTravaux ) {
        this.dateFinTravaux = dateFinTravaux;
    }
    public Date getDateFinTravaux() {
        return this.dateFinTravaux;
    }

    //--- DATABASE MAPPING : is_signed ( BIT ) 
    public void setIsSigned( Boolean isSigned ) {
        this.isSigned = isSigned;
    }
    public Boolean getIsSigned() {
        return this.isSigned;
    }

    //--- DATABASE MAPPING : is_deleted ( BIT ) 
    public void setIsDeleted( Boolean isDeleted ) {
        this.isDeleted = isDeleted;
    }
    public Boolean getIsDeleted() {
        return this.isDeleted;
    }

    //--- DATABASE MAPPING : created_at ( DATETIME ) 
    public void setCreatedAt( Date createdAt ) {
        this.createdAt = createdAt;
    }
    public Date getCreatedAt() {
        return this.createdAt;
    }

    //--- DATABASE MAPPING : updated_at ( DATETIME ) 
    public void setUpdatedAt( Date updatedAt ) {
        this.updatedAt = updatedAt;
    }
    public Date getUpdatedAt() {
        return this.updatedAt;
    }

    //--- DATABASE MAPPING : deleted_at ( DATETIME ) 
    public void setDeletedAt( Date deletedAt ) {
        this.deletedAt = deletedAt;
    }
    public Date getDeletedAt() {
        return this.deletedAt;
    }

    //--- DATABASE MAPPING : created_by ( INT ) 
    public void setCreatedBy( Integer createdBy ) {
        this.createdBy = createdBy;
    }
    public Integer getCreatedBy() {
        return this.createdBy;
    }

    //--- DATABASE MAPPING : updated_by ( INT ) 
    public void setUpdatedBy( Integer updatedBy ) {
        this.updatedBy = updatedBy;
    }
    public Integer getUpdatedBy() {
        return this.updatedBy;
    }

    //--- DATABASE MAPPING : deleted_by ( INT ) 
    public void setDeletedBy( Integer deletedBy ) {
        this.deletedBy = deletedBy;
    }
    public Integer getDeletedBy() {
        return this.deletedBy;
    }


    //----------------------------------------------------------------------
    // GETTERS & SETTERS FOR LINKS
    //----------------------------------------------------------------------

    public void setDesignationTravauxEffectues( DesignationTravauxEffectues designationTravauxEffectues ) {
        this.designationTravauxEffectues = designationTravauxEffectues;
    }
    public DesignationTravauxEffectues getDesignationTravauxEffectues() {
        return this.designationTravauxEffectues;
    }


    public void setUser( User user ) {
        this.user = user;
    }
    public User getUser() {
        return this.user;
    }


    public void setOrdreReparation( OrdreReparation ordreReparation ) {
        this.ordreReparation = ordreReparation;
    }
    public OrdreReparation getOrdreReparation() {
        return this.ordreReparation;
    }


    //----------------------------------------------------------------------
    // toString METHOD
    //----------------------------------------------------------------------
    public String toString() { 
        StringBuffer sb = new StringBuffer(); 
        sb.append("["); 
        sb.append(id);
        sb.append("]:"); 
        sb.append(dateDebutTravaux);
        sb.append("|");
        sb.append(dateFinTravaux);
        sb.append("|");
        sb.append(isSigned);
        sb.append("|");
        sb.append(isDeleted);
        sb.append("|");
        sb.append(createdAt);
        sb.append("|");
        sb.append(updatedAt);
        sb.append("|");
        sb.append(deletedAt);
        sb.append("|");
        sb.append(createdBy);
        sb.append("|");
        sb.append(updatedBy);
        sb.append("|");
        sb.append(deletedBy);
        return sb.toString(); 
    } 

	//----------------------------------------------------------------------
    // clone METHOD
    //----------------------------------------------------------------------
	@Override
	public Object clone() throws CloneNotSupportedException {
		return super.clone();
	}
}
